package com.wadpam.open.i18n.dao;

import java.io.Serializable;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import net.sf.mardao.core.CursorPage;
import net.sf.mardao.core.dao.Dao;
import com.wadpam.open.i18n.domain.Di18nTranslation;
import net.sf.mardao.core.geo.DLocation;

/**
 * DAO interface with finder methods for Di18nTranslation entities.
 *
 * Generated on 2013-03-28T09:18:31.896+0700.
 * @author mardao DAO generator (net.sf.mardao.plugin.ProcessDomainMojo)
 */
public interface GeneratedDi18nTranslationDao extends Dao<Di18nTranslation, java.lang.String> {

	/** Column name for primary key attribute is "locale" */
	static final String COLUMN_NAME_LOCALE = "locale";

	/** Column name for parent parent is "parent" */
	static final String COLUMN_NAME_PARENT = "parent";


	/** Column name for field createdBy is "createdBy" */
	static final String COLUMN_NAME_CREATEDBY = "createdBy";
	/** Column name for field createdDate is "createdDate" */
	static final String COLUMN_NAME_CREATEDDATE = "createdDate";
	/** Column name for field localizedImage is "localizedImage" */
	static final String COLUMN_NAME_LOCALIZEDIMAGE = "localizedImage";
	/** Column name for field localizedString is "localizedString" */
	static final String COLUMN_NAME_LOCALIZEDSTRING = "localizedString";
	/** Column name for field localizedUrl is "localizedUrl" */
	static final String COLUMN_NAME_LOCALIZEDURL = "localizedUrl";
	/** Column name for field updatedBy is "updatedBy" */
	static final String COLUMN_NAME_UPDATEDBY = "updatedBy";
	/** Column name for field updatedDate is "updatedDate" */
	static final String COLUMN_NAME_UPDATEDDATE = "updatedDate";

	/** The list of attribute names */
	static final List<String> COLUMN_NAMES = Arrays.asList(		COLUMN_NAME_CREATEDBY,
		COLUMN_NAME_CREATEDDATE,
		COLUMN_NAME_LOCALIZEDIMAGE,
		COLUMN_NAME_LOCALIZEDSTRING,
		COLUMN_NAME_LOCALIZEDURL,
		COLUMN_NAME_UPDATEDBY,
		COLUMN_NAME_UPDATEDDATE);
	/** The list of Basic attribute names */
	static final List<String> BASIC_NAMES = Arrays.asList(		COLUMN_NAME_CREATEDBY,
		COLUMN_NAME_CREATEDDATE,
		COLUMN_NAME_LOCALIZEDIMAGE,
		COLUMN_NAME_LOCALIZEDSTRING,
		COLUMN_NAME_LOCALIZEDURL,
		COLUMN_NAME_UPDATEDBY,
		COLUMN_NAME_UPDATEDDATE);
	/** The list of attribute names */
	static final List<String> MANY_TO_ONE_NAMES = Arrays.asList();


	// ----------------------- parent finder -------------------------------
	/**
	 * query-by method for parent field parent
	 * @param parent the specified attribute
	 * @return an Iterable of Di18nTranslations with the specified parent
	 */
	Iterable<Di18nTranslation> queryByParent(Object parent);
		
	/**
	 * query-keys-by method for parent field parent
	 * @param parent the specified attribute
	 * @return an Iterable of Di18nTranslations with the specified parent
	 */
	Iterable<java.lang.String> queryKeysByParent(Object parent);

	/**
	 * query-page-by method for parent field parent
	 * @param parent the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of Di18nTranslations for the specified parent (parent)
	 */
	CursorPage<Di18nTranslation, java.lang.String> queryPageByParent(java.lang.Object parent,
            int pageSize, Serializable cursorString);

	// ----------------------- field finders -------------------------------
	/**
	 * query-by method for field createdBy
	 * @param createdBy the specified attribute
	 * @return an Iterable of Di18nTranslations for the specified createdBy
	 */
	Iterable<Di18nTranslation> queryByCreatedBy(java.lang.String createdBy);
		
	/**
	 * query-keys-by method for field createdBy
	 * @param createdBy the specified attribute
	 * @return an Iterable of Di18nTranslations for the specified createdBy
	 */
	Iterable<java.lang.String> queryKeysByCreatedBy(java.lang.String createdBy);

	/**
	 * query-page-by method for field createdBy
	 * @param createdBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of Di18nTranslations for the specified createdBy
	 */
	CursorPage<Di18nTranslation, java.lang.String> queryPageByCreatedBy(java.lang.String createdBy,
            int pageSize, Serializable cursorString);


	/**
	 * query-by method for field createdDate
	 * @param createdDate the specified attribute
	 * @return an Iterable of Di18nTranslations for the specified createdDate
	 */
	Iterable<Di18nTranslation> queryByCreatedDate(java.util.Date createdDate);
		
	/**
	 * query-keys-by method for field createdDate
	 * @param createdDate the specified attribute
	 * @return an Iterable of Di18nTranslations for the specified createdDate
	 */
	Iterable<java.lang.String> queryKeysByCreatedDate(java.util.Date createdDate);

	/**
	 * query-page-by method for field createdDate
	 * @param createdDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of Di18nTranslations for the specified createdDate
	 */
	CursorPage<Di18nTranslation, java.lang.String> queryPageByCreatedDate(java.util.Date createdDate,
            int pageSize, Serializable cursorString);


	/**
	 * query-by method for field localizedImage
	 * @param localizedImage the specified attribute
	 * @return an Iterable of Di18nTranslations for the specified localizedImage
	 */
	Iterable<Di18nTranslation> queryByLocalizedImage(java.lang.String localizedImage);
		
	/**
	 * query-keys-by method for field localizedImage
	 * @param localizedImage the specified attribute
	 * @return an Iterable of Di18nTranslations for the specified localizedImage
	 */
	Iterable<java.lang.String> queryKeysByLocalizedImage(java.lang.String localizedImage);

	/**
	 * query-page-by method for field localizedImage
	 * @param localizedImage the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of Di18nTranslations for the specified localizedImage
	 */
	CursorPage<Di18nTranslation, java.lang.String> queryPageByLocalizedImage(java.lang.String localizedImage,
            int pageSize, Serializable cursorString);


	/**
	 * query-by method for field localizedString
	 * @param localizedString the specified attribute
	 * @return an Iterable of Di18nTranslations for the specified localizedString
	 */
	Iterable<Di18nTranslation> queryByLocalizedString(java.lang.String localizedString);
		
	/**
	 * query-keys-by method for field localizedString
	 * @param localizedString the specified attribute
	 * @return an Iterable of Di18nTranslations for the specified localizedString
	 */
	Iterable<java.lang.String> queryKeysByLocalizedString(java.lang.String localizedString);

	/**
	 * query-page-by method for field localizedString
	 * @param localizedString the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of Di18nTranslations for the specified localizedString
	 */
	CursorPage<Di18nTranslation, java.lang.String> queryPageByLocalizedString(java.lang.String localizedString,
            int pageSize, Serializable cursorString);


	/**
	 * query-by method for field localizedUrl
	 * @param localizedUrl the specified attribute
	 * @return an Iterable of Di18nTranslations for the specified localizedUrl
	 */
	Iterable<Di18nTranslation> queryByLocalizedUrl(java.lang.String localizedUrl);
		
	/**
	 * query-keys-by method for field localizedUrl
	 * @param localizedUrl the specified attribute
	 * @return an Iterable of Di18nTranslations for the specified localizedUrl
	 */
	Iterable<java.lang.String> queryKeysByLocalizedUrl(java.lang.String localizedUrl);

	/**
	 * query-page-by method for field localizedUrl
	 * @param localizedUrl the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of Di18nTranslations for the specified localizedUrl
	 */
	CursorPage<Di18nTranslation, java.lang.String> queryPageByLocalizedUrl(java.lang.String localizedUrl,
            int pageSize, Serializable cursorString);


	/**
	 * query-by method for field updatedBy
	 * @param updatedBy the specified attribute
	 * @return an Iterable of Di18nTranslations for the specified updatedBy
	 */
	Iterable<Di18nTranslation> queryByUpdatedBy(java.lang.String updatedBy);
		
	/**
	 * query-keys-by method for field updatedBy
	 * @param updatedBy the specified attribute
	 * @return an Iterable of Di18nTranslations for the specified updatedBy
	 */
	Iterable<java.lang.String> queryKeysByUpdatedBy(java.lang.String updatedBy);

	/**
	 * query-page-by method for field updatedBy
	 * @param updatedBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of Di18nTranslations for the specified updatedBy
	 */
	CursorPage<Di18nTranslation, java.lang.String> queryPageByUpdatedBy(java.lang.String updatedBy,
            int pageSize, Serializable cursorString);


	/**
	 * query-by method for field updatedDate
	 * @param updatedDate the specified attribute
	 * @return an Iterable of Di18nTranslations for the specified updatedDate
	 */
	Iterable<Di18nTranslation> queryByUpdatedDate(java.util.Date updatedDate);
		
	/**
	 * query-keys-by method for field updatedDate
	 * @param updatedDate the specified attribute
	 * @return an Iterable of Di18nTranslations for the specified updatedDate
	 */
	Iterable<java.lang.String> queryKeysByUpdatedDate(java.util.Date updatedDate);

	/**
	 * query-page-by method for field updatedDate
	 * @param updatedDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of Di18nTranslations for the specified updatedDate
	 */
	CursorPage<Di18nTranslation, java.lang.String> queryPageByUpdatedDate(java.util.Date updatedDate,
            int pageSize, Serializable cursorString);


		  
	// ----------------------- one-to-one finders -------------------------

	// ----------------------- many-to-one finders -------------------------
	
	// ----------------------- many-to-many finders -------------------------

	// ----------------------- uniqueFields finders -------------------------
	
	
	// ----------------------- populate / persist method -------------------------

	/**
	 * Persist an entity given all attributes
	 */
	Di18nTranslation persist(Object parent,  	
		java.lang.String locale, 
		java.lang.String localizedImage, 
		java.lang.String localizedString, 
		java.lang.String localizedUrl);	

}
